.Const

.Data?

.Data

sz100000			Byte		"0 - 100#000", 0
sz500000			Byte		"0 - 500#000", 0
sz1000000			Byte		"0 - 1#000#000", 0
sz5000000			Byte		"0 - 5#000#000", 0
sz10000000			Byte		"0 - 10#000#000", 0
sz20000000			Byte		"0 - 20#000#000", 0
sz50000000			Byte		"0 - 50#000#000", 0
sz100000000			Byte		"0 - 100#000#000", 0
sz200000000			Byte		"0 - 200#000#000", 0
sz300000000			Byte		"0 - 300#000#000", 0
sz600000000			Byte		"0 - 600#000#000", 0
sz1024000000		Byte		"0 - 1024#000#000", 0

lFilterMode			DWord		0

crCurrentDownColor	COLORREF	0
crMeterNewDownColor	COLORREF	0
crMeterOldDownColor	COLORREF	0
crCurrentUpColor	COLORREF	0
crMeterNewUpColor	COLORREF	0
crMeterOldUpColor	COLORREF	0

hIconDown			HICON		NULL
hIconUp				HICON		NULL


include ECProtos.inc ; .Code

SettingsProcedure Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Local chColor:CHOOSECOLOR

	.If uMsg == WM_CREATE
    	Lea Esi, szBuffer
		Invoke LoadAndSetText, hWnd, Esi, IDS_CANCEL, IDC_SETTINGS_BTNCANCEL
		Invoke LoadAndSetText, hWnd, Esi, IDS_OK, IDC_SETTINGS_BTNOK
		Invoke LoadAndSetText, hWnd, Esi, IDS_METER, IDC_SETTINGS_GROUP1
		Invoke LoadAndSetText, hWnd, Esi, IDS_TRANSFER_SPEED, IDC_SETTINGS_GROUP2
		Invoke LoadAndSetText, hWnd, Esi, IDS_COLOR, IDC_SETTINGS_GROUP3
		Invoke LoadAndSetText, hWnd, Esi, IDS_RANGE, IDC_SETTINGS_GROUP4
		Invoke LoadAndSetText, hWnd, Esi, IDS_PORTS, IDC_SETTINGS_GROUP5
		Invoke LoadAndSetText, hWnd, Esi, IDS_NF, IDC_SETTINGS_RADIO3
		Invoke LoadAndSetText, hWnd, Esi, IDS_PROM, IDC_SETTINGS_RADIO4
		Invoke LoadAndSetText, hWnd, Esi, IDS_WF, IDC_SETTINGS_RADIO5
		Invoke LoadAndSetText, hWnd, Esi, IDS_DOWNLOAD, IDC_SETTINGS_STATIC1
		Invoke LoadAndSetText, hWnd, Esi, IDS_UPLOAD, IDC_SETTINGS_STATIC2
		Invoke LoadAndSetText, hWnd, Esi, IDS_EVERY, IDC_SETTINGS_STATIC3
		Invoke LoadAndSetText, hWnd, Esi, IDS_SECONDS, IDC_SETTINGS_STATIC4

		Mov Eax, crMeterDownColor
		Mov crCurrentDownColor, Eax
		Mov crMeterNewDownColor, Eax
		Mov crMeterOldDownColor, Eax
		Mov Eax, crMeterUpColor
		Mov crCurrentUpColor, Eax
		Mov crMeterNewUpColor, Eax
		Mov crMeterOldUpColor, Eax
		Mov Eax, FilterMode
		Mov lFilterMode, Eax
		Invoke SetRightSeparator, Addr sz100000
		Invoke SetRightSeparator, Addr sz500000
		Invoke SetRightSeparator, Addr sz1000000
		Invoke SetRightSeparator, Addr sz5000000
		Invoke SetRightSeparator, Addr sz10000000
		Invoke SetRightSeparator, Addr sz20000000
		Invoke SetRightSeparator, Addr sz50000000
		Invoke SetRightSeparator, Addr sz100000000
		Invoke SetRightSeparator, Addr sz200000000
		Invoke SetRightSeparator, Addr sz300000000
		Invoke SetRightSeparator, Addr sz600000000
		Invoke SetRightSeparator, Addr sz1024000000
		Invoke LoadImage, App.Instance, IDI_ICON_DOWN_ON, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconDown, Eax
		Invoke LoadImage, App.Instance, IDI_ICON_UP_ON, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
		Mov hIconUp, Eax
		.If crMeterDownColor != 00FFFF00H
			Invoke ChangeIconColor, hIconDown, 00FFFF00H, crMeterDownColor
			.If Eax
				Xchg hIconDown, Eax
				Invoke DestroyIcon, Eax
			.EndIf
			Invoke ChangeIconColor, hIconReceive, 00FFFF00H, crMeterDownColor
			.If Eax
				Xchg hIconReceive, Eax
				Invoke DestroyIcon, Eax
			.EndIf
			Invoke ChangeIconColor, hIconBoth, 00FFFF00H, crMeterDownColor
			.If Eax
				Xchg hIconBoth, Eax
				Invoke DestroyIcon, Eax
			.EndIf
		.EndIf
		.If crMeterUpColor != 0000FFFFH
			Invoke ChangeIconColor, hIconUp, 0000FFFFH, crMeterUpColor
			.If Eax
				Xchg hIconUp, Eax
				Invoke DestroyIcon, Eax
			.EndIf
			Invoke ChangeIconColor, hIconSend, 0000FFFFH, crMeterUpColor
			.If Eax
				Xchg hIconSend, Eax
				Invoke DestroyIcon, Eax
			.EndIf
			Invoke ChangeIconColor, hIconBoth, 0000FFFFH, crMeterUpColor
			.If Eax
				Xchg hIconBoth, Eax
				Invoke DestroyIcon, Eax
			.EndIf
		.EndIf
		Mov Eax, Esi
		Mov Byte Ptr [Eax], VK_SPACE
		Inc Eax
		Invoke LoadAppString, IDS_SETTINGS, Eax, 64
		Invoke GetNoEllipsisText, Esi
		Invoke GetNoPrefixString, Esi
		Invoke SetText, hWnd, Esi
		Invoke LoadAppString, IDS_REFRESH, Esi, 64
		Invoke GetNoPrefixString, Esi
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_GROUP6
		Invoke SetWindowText, Eax, Esi

		.If bBits
			Invoke GetWindowItem, hWnd, IDC_SETTINGS_RADIO1
			Invoke SendMessage, Eax, BM_SETCHECK, BST_CHECKED, 0
		.EndIf
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_COMBO1
		Mov Edi, Eax
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_COMBO2
		Mov Esi, Eax
		Invoke SendMessage, Edi, CB_RESETCONTENT, 0, 0
		Invoke SendMessage, Esi, CB_RESETCONTENT, 0, 0
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz100000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz100000
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz500000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz500000
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz1000000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz1000000
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz5000000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz5000000
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz10000000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz10000000
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz20000000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz20000000
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz50000000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz50000000
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz100000000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz100000000
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz200000000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz200000000
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz300000000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz300000000
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz600000000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz600000000
		Invoke SendMessage, Edi, CB_ADDSTRING, 0, Addr sz1024000000
		Invoke SendMessage, Esi, CB_ADDSTRING, 0, Addr sz1024000000

		Invoke SendMessage, Edi, CB_SETCURSEL, lMeterDownMaxValueEnum, 0
		Invoke SendMessage, Esi, CB_SETCURSEL, lMeterUpMaxValueEnum, 0
		Invoke String, lAutoRefreshPorts, Addr szBuffer, ecDecimal
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_EDIT1
		Invoke SetWindowText, Eax, Addr szBuffer
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_BTNCANCEL
		Invoke SetDefault, Eax, TRUE
		Invoke GetWindowItem, hWnd, IDC_SETTINGS_BTNOK
		Invoke SetEnabled, Eax, FALSE

		.If lFilterMode == 0
			Mov Eax, IDC_SETTINGS_RADIO3
		.ElseIf lFilterMode == 1
			Mov Eax, IDC_SETTINGS_RADIO4
		.ElseIf lFilterMode == 2
			Mov Eax, IDC_SETTINGS_RADIO5
		.EndIf
		Invoke GetWindowItem, hWnd, Eax
		Invoke SendMessage, Eax, BM_SETCHECK, BST_CHECKED, 0

		.If KBValue == 1024
			Mov Eax, IDC_SETTINGS_RADIO6
		.Else
			Mov Eax, IDC_SETTINGS_RADIO7
		.EndIf
		Invoke GetWindowItem, hWnd, Eax
		Invoke SendMessage, Eax, BM_SETCHECK, BST_CHECKED, 0

	.ElseIf uMsg == WM_COMMAND
		LoWord wParam
		.If Ax == IDC_SETTINGS_BTNCANCEL
			HiWord wParam
			.If Ax == BN_CLICKED
				Invoke SendMessage, hWnd, WM_CLOSE, 0, 0
				Return TRUE
			.EndIf
		.ElseIf Ax == IDC_SETTINGS_RADIO1 || Ax == IDC_SETTINGS_RADIO2
			HiWord wParam
			.If Ax == BN_CLICKED
L2:				Invoke GetWindowItem, hWnd, IDC_SETTINGS_BTNOK
				Mov Edi, Eax
				Invoke EnableWindow, Eax, TRUE
				Invoke SetDefault, Edi, TRUE
				Return TRUE
			.EndIf
		.ElseIf Ax == IDC_SETTINGS_COMBO1 || Ax == IDC_SETTINGS_COMBO2
			HiWord wParam
			.If Ax == CBN_SELCHANGE
				Jmp L2
			.EndIf
		.ElseIf Ax == IDC_SETTINGS_BTNDOWN || Ax == IDC_SETTINGS_BTNUP
			Mov Ebx, Eax
			HiWord wParam
			.If Ax == BN_CLICKED
				Mov chColor.lStructSize, SizeOf CHOOSECOLOR
				Move chColor.hwndOwner, hWnd
				Mov chColor.hInstance, NULL
				Mov Eax, crMeterNewDownColor
				.If Bx == IDC_SETTINGS_BTNUP
					Mov Eax, crMeterNewUpColor
				.EndIf
				Mov chColor.rgbResult, Eax
				Mov chColor.lpCustColors, Offset szBuffer
				Mov chColor.Flags, CC_ANYCOLOR
				Cmp chColor.rgbResult, 0
				Jl @F
				Or chColor.Flags, CC_RGBINIT
@@:				Mov chColor.lCustData, NULL
				Mov chColor.lpfnHook, NULL
				Mov chColor.lpTemplateName, NULL
				Invoke ChooseColor, Addr chColor
				.If Eax
					Mov Eax, chColor.rgbResult
					Lea Edi, crMeterNewDownColor
					.If Bx == IDC_SETTINGS_BTNUP
						Lea Edi, crMeterNewUpColor
					.EndIf
					.If (Eax != DWord Ptr [Edi])
						Mov DWord Ptr [Edi], Eax
						Mov Eax, hIconDown
						Mov Edx, crMeterNewDownColor
						.If Bx == IDC_SETTINGS_BTNUP
							Mov Eax, hIconUp
							Mov Edx, crMeterNewUpColor
						.EndIf
						Push Edx
						Lea Esi, hIconDown
						Mov Eax, IDI_ICON_DOWN_WHITE
						.If Bx == IDC_SETTINGS_BTNUP
							Lea Esi, hIconUp
							Mov Eax, IDI_ICON_UP_WHITE
						.EndIf
						Invoke LoadImage, App.Instance, Eax, IMAGE_ICON, 16, 16, LR_LOADMAP3DCOLORS
						Xchg DWord Ptr [Esi], Eax
						Invoke DestroyIcon, Eax
						Pop Edx
						Invoke ChangeIconColor, DWord Ptr [Esi], 00FFFFFFH, Edx
						Mov Edi, IDC_SETTINGS_IMGDOWN
						Lea Esi, hIconDown
						.If Bx == IDC_SETTINGS_BTNUP
							Mov Edi, IDC_SETTINGS_IMGUP
							Lea Esi, hIconUp
						.EndIf
						Xchg DWord Ptr [Esi], Eax
						Invoke DestroyIcon, Eax
						Invoke GetWindowItem, hWnd, Edi
						Invoke InvalidateRect, Eax, NULL, TRUE
						Lea Edi, crMeterOldDownColor
						.If Bx == IDC_SETTINGS_BTNUP
							Lea Edi, crMeterOldUpColor
						.EndIf
						Mov Eax, chColor.rgbResult
						Mov DWord Ptr [Edi], Eax
						Jmp L2
					.EndIf
				.EndIf
				Return TRUE
			.EndIf
		.ElseIf Ax == IDC_SETTINGS_EDIT1
			HiWord wParam
			.If Ax == EN_CHANGE
				Jmp L2
			.EndIf
		.ElseIf Ax == IDC_SETTINGS_BTNOK
			HiWord wParam
			.If Ax == BN_CLICKED
				Invoke GetWindowItem, hWnd, IDC_SETTINGS_RADIO1
				Invoke SendMessage, Eax, BM_GETCHECK, 0, 0
				.If Eax == BST_UNCHECKED
					Mov bBits, FALSE
				.Else
					Mov bBits, TRUE
				.EndIf
				Invoke wsprintf, Addr szBuffer, Addr szFormat, bBits
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szBits, Addr szBuffer

				Invoke GetWindowItem, hWnd, IDC_SETTINGS_COMBO1
				Invoke SendMessage, Eax, CB_GETCURSEL, 0, 0
				Mov lMeterDownMaxValueEnum, Eax
				Invoke wsprintf, Addr szBuffer, Addr szFormat, Eax
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterDownMaxValueEnum, Addr szBuffer
				Invoke CheckMeterMaxValue, lMeterDownMaxValueEnum, Addr lMeterDownMaxValue
				Invoke SetMeterMaxValue, lMeterDownIndex, lMeterDownMaxValue
				
				Invoke GetWindowItem, hWnd, IDC_SETTINGS_COMBO2
				Invoke SendMessage, Eax, CB_GETCURSEL, 0, 0
				Mov lMeterUpMaxValueEnum, Eax
				Invoke wsprintf, Addr szBuffer, Addr szFormat, Eax
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterUpMaxValueEnum, Addr szBuffer
				Invoke CheckMeterMaxValue, lMeterUpMaxValueEnum, Addr lMeterUpMaxValue
				Invoke SetMeterMaxValue, lMeterUpIndex, lMeterUpMaxValue

				Mov Eax, lFilterMode
				Mov FilterMode, Eax
				Invoke wsprintf, Addr szBuffer, Addr szFormat, Eax
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szFilterMode, Addr szBuffer

				Invoke GetWindowItem, hWnd, IDC_SETTINGS_RADIO6
				Invoke SendMessage, Eax, BM_GETCHECK, 0, 0
				.If Eax == BST_CHECKED
					Mov Eax, 1024
				.Else
					Mov Eax, 1000
				.EndIf
				Mov KBValue, Eax
				Invoke StringA, Eax, Addr szBuffer, ecDecimal
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szKBValue, Addr szBuffer
				Invoke SetKBValues

				Mov Eax, crMeterNewDownColor
				.If Eax != crMeterDownColor
					Mov crMeterDownColor, Eax
					Invoke StringA, Eax, Addr szBuffer, ecDecimal
					Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterDownColor, Addr szBuffer
					Invoke SetMeterDownNewColor, crCurrentDownColor
				.EndIf
				Mov Eax, crMeterNewUpColor
				.If Eax != crMeterUpColor
					Mov crMeterUpColor, Eax
					Invoke StringA, Eax, Addr szBuffer, ecDecimal
					Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szMeterUpColor, Addr szBuffer
					Invoke SetMeterUpNewColor, crCurrentUpColor
				.EndIf
				Invoke SetIcons, IconData.hIcon
				Invoke UpdateLights, TRUE, TRUE
				Invoke GetWindowItem, hWnd, IDC_SETTINGS_EDIT1
				Invoke GetWindowText, Eax, Addr szBuffer, 2
				Invoke ValueA, Addr szBuffer
				Mov lAutoRefreshPorts, Eax
				Invoke SetRegistryValueA, HKEY_CURRENT_USER, Addr szRegistryKey, Addr szAutoRefreshPorts, Addr szBuffer
				Invoke EndModal, hWnd, IDOK
				Return TRUE
			.EndIf
		.ElseIf Ax == IDC_SETTINGS_RADIO3
			HiWord wParam
			.If Ax == BN_CLICKED
				Mov lFilterMode, 0
				Jmp L2
			.EndIf
		.ElseIf Ax == IDC_SETTINGS_RADIO4
			HiWord wParam
			.If Ax == BN_CLICKED
				Mov lFilterMode, 1
				Mov lLastBytesInIndex, 0
				Mov lLastBytesOutIndex, 0
				Invoke RtlZeroMemory, Addr lpLastBytesIn, SizeOf LPLONG * 16
				Invoke RtlZeroMemory, Addr lpLastBytesOut, SizeOf LPLONG * 16
				Jmp L2
			.EndIf
		.ElseIf Ax == IDC_SETTINGS_RADIO5
			HiWord wParam
			.If Ax == BN_CLICKED
				Mov lFilterMode, 2
				Mov DWord Ptr lpLastBytesIn, 0
				Mov DWord Ptr lpLastBytesOut, 0
				Finit
				Jmp L2
			.EndIf
		.ElseIf Ax == IDC_SETTINGS_RADIO6 || Ax == IDC_SETTINGS_RADIO7
			HiWord wParam
			.If Ax == BN_CLICKED
				Jmp L2
			.EndIf
		.EndIf
	.ElseIf uMsg == WM_CLOSE
		Invoke EndModal, hWnd, IDCANCEL
		Return TRUE
	.ElseIf uMsg == WM_DESTROY
		Invoke DestroyIcon, hIconDown
		Invoke DestroyIcon, hIconUp
	.EndIf
	Return FALSE
SettingsProcedure EndP

SettingsImgDown Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	.If uMsg == WM_PAINT
		Invoke PaintImage, hWnd, hIconDown
		Return TRUE
	.EndIf
	Xor Eax, Eax
	Ret
SettingsImgDown EndP

SettingsImgUp Proc Private hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	.If uMsg == WM_PAINT
		Invoke PaintImage, hWnd, hIconUp
		Return TRUE
	.EndIf
	Xor Eax, Eax
	Ret
SettingsImgUp EndP

PaintImage Proc Private hWnd:HWND, hIcon:HICON
	Local ps:PAINTSTRUCT

	Invoke BeginPaint, hWnd, Addr ps
	Invoke GetClientRect, hWnd, Addr ps.rcPaint
	Invoke GetSysColorBrush, COLOR_BTNFACE
	Invoke FillRect, ps.hdc, Addr ps.rcPaint, Eax
	Invoke DrawIconEx, ps.hdc, 4, 3, hIcon, 16, 16, NULL, NULL, DI_NORMAL
	Invoke EndPaint, hWnd, Addr ps
	Ret
PaintImage EndP

SetRightSeparator Proc Private Uses Esi lpszString:LPSTR
	Mov Esi, lpszString
	Mov Al, sThousand
	.While Byte Ptr [Esi] != 0
		.If Byte Ptr [Esi] == "#"
			Mov Byte Ptr [Esi], Al
		.EndIf
		Inc Esi
	.EndW
	Ret
SetRightSeparator EndP
